From 2ea035e6db7580d12ff7aa9e8d4a67c2de5eb1ec Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 720/1001] Convert the githubissues widget


---

diff --git a/hubs/validators.py b/hubs/validators.py
old mode 100755
new mode 100644
index bd5b3f2..e065629
--- a/hubs/validators.py
+++ b/hubs/validators.py
@@ -34,6 +34,10 @@ def github_organization(session, value):
     # TODO -- implement this.
     return value
 
+def github_repo(session, value):
+    # TODO -- implement this.
+    return value
+
 
 def fmn_context(session, value):
     # TODO get this from the fedmsg config.
diff --git a/hubs/widgets/githubissues/__init__.py b/hubs/widgets/githubissues/__init__.py
new file mode 100644
index 0000000..efee564
--- /dev/null
+++ b/hubs/widgets/githubissues/__init__.py
@@ -0,0 +1,82 @@
+from __future__ import unicode_literals
+
+import requests
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+
+class GitHubIssues(Widget):
+
+    name = "githubissues"
+    position = "right"
+    arguments = [
+        dict(
+            name="org",
+            label="Username",
+            default=None,
+            validator=validators.github_organization,
+            help="Github Organization or username",
+        ), dict(
+            name="repo",
+            label="Repository",
+            default=None,
+            validator=validators.github_repo,
+            help="Github repository",
+        ), dict(
+            name="display_number",
+            label="Number of tickets",
+            default=10,
+            validator=validators.integer,
+            help="The number of tickets to display.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/githubissues.html"
+    chrome = panel("Github: Newest Open Tickets")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_issues = GetIssues(instance)
+        return dict(
+            org=instance.config["org"],
+            repo=instance.config["repo"],
+            display_number=int(instance.config["display_number"]),
+            all_issues=get_issues(),
+        )
+
+
+class GetIssues(CachedFunction):
+    ''' Data for Github Issues widget. Queries github api for issues '''
+
+    def execute(self):
+        org = self.instance.config["org"]
+        repo = self.instance.config["repo"]
+        display_number = int(self.instance.config["display_number"])
+        url = '/'.join(['https://api.github.com/repos', org, repo, "issues"])
+        issues = requests.get(url).json()
+
+        all_issues = []
+        for issue in issues[:display_number]:
+            issue_details = {}
+            issue_details['num'] = issue['number']
+            issue_details['title'] = issue['title']
+            issue_details['openedby'] = issue['user']['login']
+
+            issue_assignee = None
+            if issue['assignee'] is not None:
+                issue_assignee = issue['assignee']['login']
+
+            issue_details['assignee'] = issue_assignee
+            all_issues.append(issue_details)
+
+        all_issues.reverse()
+        return all_issues
+
+    def should_invalidate(self, message):
+        raise NotImplementedError

